<template>
  <div
    class="mainPadding"
    style="width: 100%; max-width: 1600px; margin: auto; height: 100px"
  >
    <div>
      <div align="right" style="100%">
        <div
          @click="addNewAdsBtn()"
          class="adNewUser row items-center justify-evenly"
        >
          <q-icon size="21px" name="fa-solid fa-plus" />
          <div class="font16">เพิ่มโฆษณา</div>
        </div>
      </div>
      <div class="row">
        <div class="col-6 q-pa-md" v-for="(item, index) in data" :key="index">
          <div class="mainAdsDiv q-pa-md">
            <div class="row">
              <div class="col">
                ลิงค์ URL :
                <span @click="goToLink(item.urltarget)" class="linkTarget">{{
                  item.urltarget
                }}</span>
              </div>
              <div style="width: 80px" align="right ">
                <div
                  class="onlinebtn"
                  align="center"
                  v-if="item.online == 1"
                  @click="changeOffline(item.id)"
                >
                  Online
                </div>
                <div
                  class="offlinebtn"
                  align="center"
                  v-else
                  @click="changeOnline(item.id)"
                >
                  Offline
                </div>
              </div>
            </div>
            <div class="q-pt-md">
              <img :src="openPic(item.id)" alt="" width="100%" />
            </div>
            <div align="center">
              <div>จำนวน {{ item.userclick }} คลิก</div>
            </div>
            <div class="row justify-center">
              <div class="q-px-md">
                <span class="linkurl" @click="previewAds(item.id)"
                  >ดูตัวอย่าง</span
                >
              </div>
              <div class="q-px-md">
                <span class="linkurl" @click="editBtn(item.id)">แก้ไข</span>
              </div>
              <div class="q-px-md">
                <span class="linkurl" @click="delBtn(item.id)">ลบ</span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- add new ads dialog -->
    <q-dialog v-model="addNewAdsDia" persistent>
      <q-card style="width: 700px; max-width: 80vw">
        <q-card-section>
          <div class="row">
            <div class="col"></div>
            <div class="">
              <img src="../../public/image/alertAdd.svg" alt="" />
            </div>
            <div style="width: 15px"></div>
            <div class="font22" align="center">เพิ่มโฆษณา</div>
            <div align="center"></div>
            <div class="col"></div>
          </div>
          <hr style="width: " />
        </q-card-section>
        <q-card-section>
          <div class="row items-center">
            <div class="font18 col-4" style="padding-left: 15px" align="left">
              ลิงค์ URL
            </div>
            <q-input
              class="col"
              style="width: 410px:"
              outlined
              v-model.trim="input.url"
              dense
            />
            <div style="padding-right: 10px"></div>
          </div>
          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับมือถือ</div>
              <div class="label-picsize">ขนาด 340x70 px</div>
            </div>
            <q-input
              class="col"
              style=""
              outlined
              v-model="input.mobileFile"
              dense
              type="file"
              accept=".jpg"
            />
            <div style="padding-right: 10px"></div>
          </div>

          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับแท็บเล็ต</div>
              <div class="label-picsize">ขนาด 720x150 px</div>
            </div>
            <q-input
              class="col"
              style=""
              outlined
              v-model="input.tabletFile"
              dense
              type="file"
              accept=".jpg"
            />
            <div style="padding-right: 10px"></div>
          </div>

          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับคอม</div>
              <div class="label-picsize">ขนาด 1440x300 px</div>
            </div>
            <q-input
              class="col"
              style=""
              outlined
              v-model="input.pcFileData"
              dense
              type="file"
              accept=".jpg"
            />
            <div style="padding-right: 10px"></div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <div
              class="cancelAdNewUserDiaBtn"
              @click="closeAddNewAdsDia()"
              align="center"
            >
              ยกเลิก
            </div>
            <div style="width: 20px"></div>
            <div
              @click="saveNewAdsBtn()"
              class="saveAddNewAdsDiaBtn"
              align="center"
            >
              ตกลง
            </div>
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>

    <!-- edit ads dialog -->
    <q-dialog v-model="editAdsDialog" persistent>
      <q-card style="width: 700px; max-width: 80vw">
        <q-card-section>
          <div class="row">
            <div class="col"></div>
            <div class="">
              <img src="../../public/image/alertEditPenIcon.svg" alt="" />
            </div>
            <div style="width: 15px"></div>
            <div class="font22" align="center">แก้โฆษณา</div>
            <div align="center"></div>
            <div class="col"></div>
          </div>
          <hr style="width: " />
        </q-card-section>
        <q-card-section>
          <div class="row items-center">
            <div class="font18 col-4" style="padding-left: 15px" align="left">
              ลิงค์ URL
            </div>
            <q-input
              class="col"
              style="width: 410px:"
              outlined
              v-model.trim="editInput.url"
              dense
            />
            <div style="padding-right: 10px"></div>
          </div>
          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับมือถือ</div>
              <div class="label-picsize">ขนาด 340x70 px</div>
            </div>
            <div v-if="!editInput.delMobileFile">
              {{ editInput.mobileFile }}
              <q-icon
                name="fa-solid fa-trash-can"
                class="cursor-pointer"
                @click="delMobileFile()"
              />
            </div>
            <div v-else>
              <q-input
                class="col"
                style=""
                outlined
                v-model="editInput.mobileFile"
                dense
                type="file"
                accept=".jpg"
              />
            </div>
            <div style="padding-right: 10px"></div>
          </div>

          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับแท็บเล็ต</div>
              <div class="label-picsize">ขนาด 720x150 px</div>
            </div>
            <div v-if="!editInput.delTabletFile">
              {{ editInput.tabletFile }}
              <q-icon
                name="fa-solid fa-trash-can"
                class="cursor-pointer"
                @click="delTabletFile()"
              />
            </div>
            <div v-else>
              <q-input
                class="col"
                style=""
                outlined
                v-model="editInput.tabletFile"
                dense
                type="file"
                accept=".jpg"
              />
            </div>
            <div style="padding-right: 10px"></div>
          </div>

          <div class="row items-center q-pt-lg">
            <div class="font18 col-4" style="padding-left: 16px" align="left">
              <div>รูปภาพสำหรับคอม</div>
              <div class="label-picsize">ขนาด 1440x300 px</div>
            </div>
            <div v-if="!editInput.delPcFile">
              {{ editInput.pcFileData }}
              <q-icon
                name="fa-solid fa-trash-can"
                class="cursor-pointer"
                @click="delPcFile()"
              />
            </div>
            <div v-else>
              <q-input
                class="col"
                style=""
                outlined
                v-model="editInput.pcFileData"
                dense
                type="file"
                accept=".jpg"
              />
            </div>
            <div style="padding-right: 10px"></div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <div
              class="cancelAdNewUserDiaBtn"
              @click="closeEditAdsDia()"
              align="center"
            >
              ยกเลิก
            </div>
            <div style="width: 20px"></div>
            <div
              @click="saveEditAdsBtn()"
              class="saveAddNewAdsDiaBtn"
              align="center"
            >
              ตกลง
            </div>
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>
    <!-- preview dialog -->
    <q-dialog v-model="previewDialog" persistent>
      <q-card style="width: 1200px; max-width: 1200px">
        <q-card-section>
          <div class="items-center">
            <div class="row">
              <div class="col"></div>
              <img src="../../public/image/previeweye.svg" alt="" />
              <div style="width: 15px"></div>
              <div class="font18">ดูตัวอย่าง</div>
              <div class="col"></div>
            </div>
          </div>

          <hr style="width: 100%" />
          <div class="row">
            <div class="label-preview">Mobile</div>
            <div class="col"><img :src="picFile.mobile" /></div>
          </div>
          <div class="row q-pt-md">
            <div class="label-preview">Tablet</div>
            <div class="col"><img :src="picFile.tablet" /></div>
          </div>
          <div class="row q-pt-md">
            <div class="label-preview">PC</div>
            <div class="col"><img :src="picFile.pc" width="1000px" /></div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <div
              class="cancelAdNewUserDiaBtn"
              @click="closePreviewDia()"
              align="center"
            >
              ปิด
            </div>
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>

    <!-- alert delete dialog  -->
    <q-dialog v-model="delAdsDia" persistent>
      <q-card>
        <q-card-section>
          <div class="items-center">
            <div class="row">
              <div class="col"></div>
              <img src="../../public/image/alertBinIcon.svg" alt="" />
              <div style="width: 15px"></div>
              <div class="font18">ลบโฆษณา</div>
              <div class="col"></div>
            </div>
          </div>

          <hr style="width: 400px" />
          <div align="center">
            <div>คุณต้องการลบโฆษณา: ?</div>
          </div>
        </q-card-section>
        <q-card-actions align="center">
          <div class="row">
            <div
              class="cancelAdNewUserDiaBtn"
              @click="closeDelAdDia()"
              align="center"
            >
              ยกเลิก
            </div>
            <div style="width: 20px"></div>
            <div
              @click="confirmDelAdBtn()"
              class="submitAdNewUserDiaBtn"
              align="center"
            >
              ลบ
            </div>
          </div>
        </q-card-actions>
        <br />
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      addNewAdsDia: false,
      input: {
        url: undefined,
        mobileFile: "",
        tabletFile: "",
        pcFileData: "",
      },
      data: [],
      previewDialog: false,
      picFile: {
        mobile: "",
        tablet: "",
        pc: "",
      },
      delAdsDia: false,
      delID: 0,
      editAdsDialog: false,
      editInput: {
        Id: "",
        url: "",
        mobileFile: undefined,
        delMobileFile: false,
        tabletFile: undefined,
        delTabletFile: false,
        pcFileData: undefined,
        delPcFile: false,
      },
    };
  },
  methods: {
    async saveEditAdsBtn() {
      if (
        this.editInput.url.length == 0 ||
        (this.editInput.delMobileFile &&
          this.editInput.mobileFile == undefined) ||
        (this.editInput.delTabletFile &&
          this.editInput.tabletFile == undefined) ||
        (this.editInput.delPcFile && this.editInput.pcFileData == undefined)
      ) {
        this.redNotify("กรุณากรอกข้อมูลให้ครบถ้วน");
        return;
      }
      {
        let dataSend = {
          id: this.editInput.Id,
          url: this.editInput.url,
        };
        let urlInfo = this.serverpath + "updateadsinfo.php";
        let res = await axios.post(urlInfo, JSON.stringify(dataSend));
      }
      if (this.editInput.delMobileFile) {
        if (this.editInput.mobileFile != undefined) {
          let formData = new FormData();
          formData.append("id", this.editInput.Id);
          formData.append("filename", this.editInput.mobileFile[0].name);
          formData.append("mobilefile", this.editInput.mobileFile[0]);
          const headers = { "Content-Type": "multipart/form-data" };
          await axios.post(this.serverpath + "editadsmobile.php", formData, {
            headers,
          });
        }
      }
      if (this.editInput.delTabletFile) {
        if (this.editInput.tabletFile != undefined) {
          let formData = new FormData();
          formData.append("id", this.editInput.Id);
          formData.append("filename", this.editInput.pcFileData[0].name);
          formData.append("pcfile", this.editInput.pcFileData[0]);
          const headers = { "Content-Type": "multipart/form-data" };
          await axios.post(this.serverpath + "editadspc.php", formData, {
            headers,
          });
        }
      }
      if (this.editInput.delPcFile) {
        if (this.editInput.pcFileData != undefined) {
          let formData = new FormData();
          formData.append("id", this.editInput.Id);
          formData.append("filename", this.editInput.tabletFile[0].name);
          formData.append("tabletfile", this.editInput.tabletFile[0]);
          const headers = { "Content-Type": "multipart/form-data" };
          await axios.post(this.serverpath + "editadstablet.php", formData, {
            headers,
          });
        }
      }

      this.loadData();
      this.editAdsDialog = false;
    },
    delPcFile() {
      this.editInput.delPcFile = true;
      this.editInput.pcFileData = undefined;
    },
    delTabletFile() {
      this.editInput.delTabletFile = true;
      this.editInput.tabletFile = undefined;
    },
    delMobileFile() {
      this.editInput.delMobileFile = true;
      this.editInput.mobileFile = undefined;
    },
    closeEditAdsDia() {
      this.editAdsDialog = false;
    },
    editBtn(id) {
      this.editAdsDialog = true;
      let dataEdit = this.data.filter((x) => x.id == id);
      this.editInput.Id = id;
      this.editInput.delMobileFile = false;
      this.editInput.delTabletFile = false;
      this.editInput.delPcFile = false;
      this.editInput.mobileFile = undefined;
      this.editInput.tabletFile = undefined;
      this.editInput.pcFileData = undefined;
      this.editInput.url = dataEdit[0].urltarget;
      this.editInput.mobileFile = dataEdit[0].mobilefile;
      this.editInput.tabletFile = dataEdit[0].tabletfile;
      this.editInput.pcFileData = dataEdit[0].pcfile;
    },
    async confirmDelAdBtn() {
      let key = this.$q.localStorage.getItem("key");
      let dataSend = {
        key: key,
        id: this.delID,
      };
      let url = this.serverpath + "deleteAdBtn.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      if (res.data == "go to welcome") {
        this.$router.push("welcome");
        return;
      } else if (res.data == "go to login") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      } else {
        this.loadData();
        this.delAdsDia = false;
      }
    },
    closeDelAdDia() {
      this.delAdsDia = false;
    },
    delBtn(id) {
      this.delID = id;
      this.delAdsDia = true;
    },
    closePreviewDia() {
      this.previewDialog = false;
    },
    previewAds(id) {
      this.picFile.mobile =
        this.serverpath +
        "market/" +
        id +
        "_mobile.jpg?" +
        Math.random() * 2000;
      this.picFile.tablet =
        this.serverpath +
        "market/" +
        id +
        "_tablet.jpg?" +
        Math.random() * 2000;
      this.picFile.pc =
        this.serverpath + "market/" + id + "_pc.jpg?" + Math.random() * 2000;
      this.picFile;
      this.previewDialog = true;
    },
    async changeOnline(id) {
      let dataSend = {
        online: 1,
        id: id,
      };
      let url = this.serverpath + "updateadsonline.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.loadData();
    },
    async changeOffline(id) {
      let dataSend = {
        online: 0,
        id: id,
      };
      let url = this.serverpath + "updateadsonline.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.loadData();
    },
    openPic(id) {
      return (
        this.serverpath + "market/" + id + "_mobile.jpg?" + Math.random() * 2000
      );
    },
    goToLink(link) {
      window.open(link);
    },
    async saveNewAdsBtn() {
      if (
        this.input.url.length > 0 &&
        this.input.mobileFile[0] != undefined &&
        this.input.tabletFile[0] != undefined &&
        this.input.pcFileData[0] != undefined
      ) {
        // basic info
        let tempData = {
          urltarget: this.input.url,
          mobilefile: this.input.mobileFile[0].name,
          tabletfile: this.input.tabletFile[0].name,
          pcfile: this.input.pcFileData[0].name,
        };
        let urlInfo = this.serverpath + "addadsinfo.php";
        let res = await axios.post(urlInfo, JSON.stringify(tempData));
        let recordId = res.data.toString();
        //add file
        const formData = new FormData();
        formData.append("id", recordId);
        formData.append("mobilefile", this.input.mobileFile[0]);

        const headers = { "Content-Type": "multipart/form-data" };
        axios.post(this.serverpath + "getnewadsmobile.php", formData, {
          headers,
        });
        const formData2 = new FormData();
        formData2.append("id", recordId);
        formData2.append("tabletfile", this.input.tabletFile[0]);
        axios.post(this.serverpath + "getnewadstablet.php", formData2, {
          headers,
        });
        const formData3 = new FormData();
        formData3.append("id", recordId);
        formData3.append("pcfileData", this.input.pcFileData[0]);
        axios.post(this.serverpath + "getnewadspc.php", formData3, {
          headers,
        });
        this.loadData();
        this.greenNotify("บันทึกข้อมูลเสร็จสิ้น");
        this.closeAddNewAdsDia();
      } else {
        this.redNotify("กรุณาใส่ข้อมูลให้ครบถ้วน");
      }
    },
    closeAddNewAdsDia() {
      this.addNewAdsDia = false;
    },
    addNewAdsBtn() {
      this.input.url = "";
      this.input.mobileFile = undefined;
      this.input.tabletFile = undefined;
      this.input.pcFileData = undefined;
      this.addNewAdsDia = true;
    },
    async loadData() {
      let key = this.$q.localStorage.getItem("key");
      let dataTemp = {
        key: key,
      };
      let urlTotal = this.serverpath + "checkads.php";
      let res = await axios.post(urlTotal, JSON.stringify(dataTemp));
      if (res.data == "go to welcome") {
        this.$router.push("welcome");
        return;
      } else if (res.data == "go to login") {
        this.$q.localStorage.clear();
        this.$router.push("/");
        return;
      } else {
        this.data = res.data;
      }
    },
  },
  mounted() {
    this.loadData();
  },
};
</script>

<style lang="scss" scoped>
.label-picsize {
  font-size: 12px;
  position: relative;
  top: -5px;
  color: #535353;
}
.label-preview {
  width: 100px;
}
.linkTarget {
  text-decoration: underline;
  cursor: pointer;
}
.adNewUser {
  width: 135px;
  height: 40px;
  line-height: 40px;
  border: 1px solid #474747;
  color: #474747;
  cursor: pointer;
}
.mainAdsDiv {
  border: 1px solid #313131;
  height: 245px;
  border-radius: 10px;
  // background-color: white;
}
.onlinebtn {
  font-size: 12px;
  color: #1f8616;
  border: 1px solid #1f8616;
  width: 60px;
  height: 25px;
  line-height: 25px;
  border-radius: 5px;
  cursor: pointer;
  margin: auto;
}
.offlinebtn {
  font-size: 12px;
  color: #ec5454;
  border: 1px solid #ec5454;
  width: 60px;
  height: 25px;
  line-height: 25px;
  border-radius: 5px;
  cursor: pointer;
  margin: auto;
}
.linkurl {
  text-decoration: underline;
  cursor: pointer;
}
.submitAddNewUserDiaBtn {
  width: 120px;
  height: 40px;
  line-height: 40px;
  color: white;
  background-color: #2d6be4;
  border-radius: 3px;
  cursor: pointer;
}
.saveAddNewAdsDiaBtn {
  width: 120px;
  height: 40px;
  line-height: 40px;
  border-radius: 5px;
  color: white;
  background-color: #2d6be4;
  border-radius: 3px;
  cursor: pointer;
}
</style>
